using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Text;
using System.Windows.Forms;
using System.Linq;

using JUNKBOX.IO;

namespace PuchiAR
{
    public partial class Form1 : Form
    {
        int _count = 0; // R}
        bool _capture = false;

        CaptureDevice camera;
        public Form1()
        {
            InitializeComponent();

            // ׂẴLv`foCX擾
            VideoCapture capture = new VideoCapture();
            List<CaptureDevice> devices = capture.Devices;

            if (devices != null)
            {
                // 0Ԗڂ̃foCX擾
                camera = devices[0];
                this.toolStripStatusLabel1.Text = camera.Name;

                // 0Ԗڂ̃foCX 320x240 pixel  Bitmap o͂悤ɏ
                camera.Activate(this.previewPanel, 320, 240);
            }
            else
            {
                this.toolStripStatusLabel1.Text = "Lv`foCX܂ł";
                this.button1.Enabled = false;
            }

            ProjectionConversion p = new ProjectionConversion(320, 240,
                0, 0, 0, 480, 640, 480, 640, 0);
            PointF q1 = p.Convert(0, 0);
            PointF q2 = p.Convert(320,240);
            PointF q3 = p.Convert(0, 240);
            PointF q4 = p.Convert(320, 0);
        }
    

        private void button1_Click(object sender, EventArgs e)
        {
            if (this.timer1.Enabled)
            {
                this.timer1.Stop();
            }
            else
            {
                _count = 0;
                this.timer1.Start();
            }
        }

        private void previewPanel_Resize(object sender, EventArgs e)
        {
            if (this.camera != null)
            {
              //  this.camera.ResizePreviewWindow();
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            // Î~Lv`
            Bitmap bmp = this.camera.Capture();

            // Bitmap  byte[] ɍϊ
            byte[] rgbValues = VideoCapture.BitmapToByteArray(bmp);
            byte[] original = new byte[rgbValues.Length];
            rgbValues.CopyTo(original, 0);

            // Lv`摜f[^̂Ql
            for (int p = 0; p < rgbValues.Length; p += 4)
            {
                // p+0:B p+1:G p+2:R p+3:A

                // Fۂ
                if (rgbValues[p] > rgbValues[p + 1] && rgbValues[p] > rgbValues[p + 2]*2)
                {
                    // ԂœhԂ
                    rgbValues[p] = 0;       // 
                    rgbValues[p + 1] = 0;   // 
                    rgbValues[p + 2] = 255; // 
                }
                else
                {
                    // ȊO͍œhԂ
                    rgbValues[p] = 0;       // 
                    rgbValues[p + 1] = 0;   // 
                    rgbValues[p + 2] = 0;   // 
                }
            }

            // hԂ͂ޒ`ꗗ擾
            List<Rectangle> rects = FindMarker(rgbValues, bmp.Width, bmp.Height);

            // `̏dSXWɃ\[g
            // ̂A傫Ȃ̂S擾
            rects = SortRectangles(rects);

            // byte[]  Bitmap ɍϊ
            //this.pictureBox1.Image = VideoCapture.ByteArrayToBitmap(rgbValues, bmp);
            //bmp = VideoCapture.ByteArrayToBitmap(rgbValues, bmp);

            if (rects.Count == 4)
            {
                Graphics g = Graphics.FromImage(bmp);
                
                // }[J[̏dSvZ
                Point[] points = new Point[4];
                int[] size = new int[4];
                for (int i = 0; i < 4; i++)
                {
                    points[i] = new Point(
                        rects[i].X + rects[i].Width / 2,
                        rects[i].Y + rects[i].Height / 2);
                    size[i] = (int)Math.Sqrt(rects[i].Width * rects[i].Width + rects[i].Height * rects[i].Height);
                }

                // Op`̖@xNgvZ(Ẑ)
                int v1 = (points[1].X - points[0].X) * (points[2].Y - points[1].Y)
                       - (points[2].X - points[1].X) * (points[1].Y - points[0].Y);
                int v2 = (points[3].X - points[2].X) * (points[0].Y - points[3].Y)
                       - (points[0].X - points[3].X) * (points[3].Y - points[2].Y);
                
                // Q̎Op`̖@̌قȂꍇ͓ւ
                if ( v1 * v2 < 0 )
                {
                    Point p = points[2];
                    points[2] = points[3];
                    points[3] = p;

                    int i = size[2];
                    size[2] = size[3];
                    size[3] = i;
                }

                // e_v̏ŕłȂꍇ͓ւ
                if (v1 < 0)
                {
                    Point p = points[1];
                    points[1] = points[3];
                    points[3] = p;

                    int i = size[1];
                    size[1] = size[3];
                    size[3] = i;
                }

                // ˉeϊZo
                double pWidth = 66*3;
                double pHeight = 22*3;
                ProjectionConversion conv = new ProjectionConversion(pWidth, pHeight,
                    points[0].X, points[0].Y, points[1].X, points[1].Y,
                    points[2].X, points[2].Y, points[3].X, points[3].Y);
                Bitmap proj = new Bitmap((int)pWidth, (int)pHeight);
                byte[] pValue = VideoCapture.BitmapToByteArray(proj);
                for (int y = 0; y < pHeight; y++)
                {
                    for (int x = 0; x < pWidth; x++)
                    {
                        int dest = (int) (x + (pHeight - y - 1) * pWidth) * 4;
                        PointF c = conv.Convert(x, y);
                        int src = (int) (((int)c.X) + ((int)c.Y) * bmp.Width) * 4;
                        if (0 <= src && src < original.Length)
                        {
                            pValue[dest++] = original[src++];
                            pValue[dest++] = original[src++];
                            pValue[dest++] = original[src++];
                            pValue[dest] = original[src];
                        }
                    }
                }
                this.pictureBoxProjection.Image = VideoCapture.ByteArrayToBitmap(pValue, proj);

                // }[J[mŌ
                for (int i = 0; i < 4; i++)
                {
                    Font font = new Font("MS UI Gothic", size[i]*3/2);
                    g.DrawLine(Pens.Red, points[i], points[(i + 1) % 4]);
                    g.DrawString(i.ToString(), font , Brushes.GreenYellow, points[i].X+10, points[i].Y+10);
                    font.Dispose();
                }
                g.DrawLine(Pens.Red, points[0], points[2]);

                // }[J[F𒷕`ň͂
                g.DrawRectangles(Pens.Red, rects.ToArray());


                this.pictureBox1.Image = bmp;
                g.Dispose();
            }
            else
            {
                this.pictureBox1.Image = bmp;
            }
            if (_capture)
            {
                _capture = false;
                bmp.Save("test" + _count.ToString().PadLeft(5, '0') + ".png", ImageFormat.Png);
            }
            timer1.Start();
            _count++;
            this.label1.Text = _count.ToString();
        }

        int _xMin, _yMin, _xMax, _yMax;

        /// <summary>
        /// }[J[Ďlp`ň݂͂܂B 
        /// 炩 ₪ԁAȊOɂȂĂ邱Ƃ҂Ă܂B
        /// </summary>
        /// <param name="data">摜̔zf[^</param>
        /// <param name="width">摜̕</param>
        /// <param name="height">摜̍</param>
        /// <returns>`̔z</returns>
        private List<Rectangle> FindMarker(byte[] data, int width, int height)
        {
            List<Rectangle> rects = new List<Rectangle>();
            for (int i = 2; i < data.Length; i += 4)
            {
                if (data[i] > 0)
                {
                    _xMin = (i / 4) % width;
                    _yMin = (i / 4) / width;
                    _xMax = _xMin;
                    _yMax = _yMin;
                    int count = MarkerPaint(data, width, height, _xMin, _yMin);

                    rects.Add(new Rectangle(_xMin, _yMin, _xMax - _xMin + 1, _yMax - _yMin + 1));
                }
            }
            return rects;
        }

        /// <summary>
        /// }[J[hԂ܂BhԂ͈͂͂ލŏ̎lp`ƂȂ悤A
        /// _xMin, _yMax, _xMax, _yMax XV܂B 
        /// </summary>
        /// <param name="data">摜̔zf[^</param>
        /// <param name="width">摜̕</param>
        /// <param name="height">摜̍</param>
        /// <param name="x">hԂ\ł邱Ƃ킩Ă_XW</param>
        /// <param name="y">hԂ\ł邱Ƃ킩Ă_YW</param>
        /// <returns>hԂ</returns>
        private int MarkerPaint(byte[] data,int width, int height, int x, int y)
        {
            // gh
            int p = (x + y * width) * 4 + 2;
            data[p] = 0;
            data[p - 1] = 255;

            int count = 1;

            // ɖhԂsNZ
            p = (x + (y - 1) * width) * 4 + 2;
            if (y > 0 && data[p] > 0)
            {
                y--;
                if (y < _yMin) _yMin = y;
                count += MarkerPaint(data, width, height, x, y);
            }

            // ɖhԂsNZ
            p = (x + (y + 1) * width) * 4 + 2;
            if (y < height - 1 && data[p] > 0)
            {
                y++;
                if (_yMax < y) _yMax = y;
                count += MarkerPaint(data, width, height, x, y);
            }

            // ɖhԂsNZ
            p = (x - 1 + y * width) * 4 + 2;
            if (x > 0 && data[p] > 0)
            {
                x--;
                if(x < _xMin) _xMin = x;
                count += MarkerPaint(data, width, height, x, y);
            }

            // EɖhԂsNZ
            p = (x + 1 + y * width) * 4 + 2;
            if (x < width - 1 && data[p] > 0)
            {
                x++;
                if(_xMax < x) _xMax = x;
                count += MarkerPaint(data, width, height, x, y);
            }

            return count;
        }

        private List<Rectangle> SortRectangles(List<Rectangle> rects)
        {
            List<Rectangle> result = new List<Rectangle>();

            // }[J[4̏ꍇ0ɂ
            if (rects.Count < 4) return result;

            // 傫Ƀ\[g
            var query = from c in rects
                        orderby c.Width * c.Height descending
                        select c;

            // 傫4o
            var query2 = query.Take(4);

            // dSXWɃ\[g
            var query3 = from c in query2
                         orderby c.X + c.Width/2
                         select c;

            result = query3.ToList<Rectangle>();
            return result;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            _capture = true;
        }
    }
}